import os
from datetime import datetime
from typing import Callable, Type, Optional

from cpl_core.application import StartupExtensionABC
from cpl_core.configuration import ConfigurationABC
from cpl_core.dependency_injection import ServiceCollectionABC
from cpl_core.environment import ApplicationEnvironmentABC

from bot_core.configuration.bot_logging_settings import BotLoggingSettings
from bot_core.configuration.bot_settings import BotSettings
from modules.base.configuration.base_settings import BaseSettings
from modules.boot_log.configuration.boot_log_settings import BootLogSettings
from modules.level.configuration.level_settings import LevelSettings
from modules.permission.configuration.permission_settings import PermissionSettings


class StartupTestExtension(StartupExtensionABC):

    def __init__(self):
        StartupExtensionABC.__init__(self)

    def configure_configuration(self, configuration: ConfigurationABC, environment: ApplicationEnvironmentABC):
        # this shit has to be done here because we need settings in subsequent startup extensions
        environment.set_working_directory(os.path.dirname(os.path.realpath(__file__)))

    def configure_services(self, services: ServiceCollectionABC, env: ApplicationEnvironmentABC):
        pass
